%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                                  PSG Type    PSG Object                         Location in Problem Statement                                                                Class
%matrix_scenarios_large_label1_data      data        matrix_scenarios_large_label1      pr_pen(parameter_alpha,L(matrix_scenarios_large_label1)-L(matrix_scenarios_large_label0))    double
%matrix_scenarios_large_label1_vars      vars        matrix_scenarios_large_label1      pr_pen(parameter_alpha,L(matrix_scenarios_large_label1)-L(matrix_scenarios_large_label0))    cell
%matrix_scenarios_large_label0_data      data        matrix_scenarios_large_label0      pr_pen(parameter_alpha,L(matrix_scenarios_large_label1)-L(matrix_scenarios_large_label0))    double
%matrix_scenarios_large_label0_vars      vars        matrix_scenarios_large_label0      pr_pen(parameter_alpha,L(matrix_scenarios_large_label1)-L(matrix_scenarios_large_label0))    cell
%matrix_orthogonal_data                  data        matrix_orthogonal                  linear(matrix_orthogonal)                                                                    double
%matrix_orthogonal_vars                  vars        matrix_orthogonal                  linear(matrix_orthogonal)                                                                    cell
%point_logistic_regression_large_data    data        point_logistic_regression_large    Solver: stages=30, init_point  = point_logistic_regression_large                             double
%point_logistic_regression_large_vars    vars        point_logistic_regression_large    Solver: stages=30, init_point  = point_logistic_regression_large                             cell
%parameter_alpha_data                    data        parameter_alpha                    pr_pen(parameter_alpha,L(matrix_scenarios_large_label1)-L(matrix_scenarios_large_label0))    double
%parameter_bound_data                    data        parameter_bound                    Constraint: ==   parameter_bound                                                             double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_scenarios_large_label1_data,matrix_scenarios_large_label1_vars,matrix_scenarios_large_label0_data,matrix_scenarios_large_label0_vars,matrix_orthogonal_data,matrix_orthogonal_vars,point_logistic_regression_large_data,point_logistic_regression_large_vars,parameter_alpha_data,parameter_bound_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_scenarios_large_label1',matrix_scenarios_large_label1_data,matrix_scenarios_large_label1_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_scenarios_large_label0',matrix_scenarios_large_label0_data,matrix_scenarios_large_label0_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_orthogonal',matrix_orthogonal_data,matrix_orthogonal_vars,[],[]);
count = count+1;
iargstruc_arr(count) = point_pack('point_logistic_regression_large',point_logistic_regression_large_data,point_logistic_regression_large_vars);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'  pr_pen(parameter_alpha,L(matrix_scenarios_large_label1)-L(matrix_scenarios_large_label0))',...
'Constraint: ==   parameter_bound',...
'  linear(matrix_orthogonal)',...
'Solver: stages=30, init_point  = point_logistic_regression_large',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));
problem_statement = strrep(problem_statement,'parameter_bound',num2str(parameter_bound_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

